<?php 
/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2005 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * "Support Open Source software. What about a donation today?"
 * 
 * File Name: GetFoldersAndFiles.php
 * 	Implements the GetFoldersAndFiles command, to list
 * 	files and folders in the current directory.
 * 	Output is in XML
 * 
 * File Authors:
 * 		Grant French (grant@mcpuk.net)
 */
class GetFoldersAndFiles 
{
	var $fckphp_config;
	var $type;
	var $cwd;
	var $actual_cwd;
	
	function GetFoldersAndFiles($fckphp_config,$type,$cwd) 
	{
		$this->fckphp_config=$fckphp_config;
		$this->type=$type;
		$this->raw_cwd=$cwd;
		//fcs
		//$this->actual_cwd=str_replace("//","/",($fckphp_config['UserFilesPath']."/$type/".$this->raw_cwd));
		$this->actual_cwd=str_replace("//","/",($fckphp_config['UserFilesPath']."/".$this->raw_cwd));
		$this->real_cwd=str_replace("//","/",($this->fckphp_config['basedir']."/".$this->actual_cwd));
	}
	
	function run() 
	{

		header ("Content-Type: application/xml; charset=utf-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
		?>
<!DOCTYPE Connector [

<?php include "dtd/iso-lat1.ent";?>
	
	<!ELEMENT Connector	(CurrentFolder,Folders,Files)>
		<!ATTLIST Connector command CDATA "noname">
		<!ATTLIST Connector resourceType CDATA "0">
		
	<!ELEMENT CurrentFolder	(#PCDATA)>
		<!ATTLIST CurrentFolder path CDATA "noname">
		<!ATTLIST CurrentFolder url CDATA "0">
		
	<!ELEMENT Folders	(#PCDATA)>
	
	<!ELEMENT Folder	(#PCDATA)>
		<!ATTLIST Folder name CDATA "noname_dir">
		
	<!ELEMENT Files		(#PCDATA)>
		
	<!ELEMENT File		(#PCDATA)>
		<!ATTLIST File name CDATA "noname_file">
		<!ATTLIST File size CDATA "0">
] >
		
<Connector command="GetFoldersAndFiles" resourceType="<?php echo $this->type; ?>">
	<CurrentFolder path="<?php echo $this->raw_cwd; ?>" url="<?php echo $this->fckphp_config['urlprefix'] . $this->actual_cwd; ?>" />
	<Folders>
<?php
		$files=array();
		$dirs = array();
		if ($dh=opendir($this->real_cwd)) 
		{
			while (($filename=readdir($dh))!==false) 
			{
				
				if (($filename!=".")&&($filename!="..")) 
				{
					if (is_dir($this->real_cwd."/$filename")) 
					{	
						array_push($dirs,$filename);
					} 
					else 
					{
						array_push($files,$filename);
					}
				}
			}
			closedir($dh); 
		}
		
		//sort the dirs and files arrays
		$array_lowercase = array_map('strtolower', $dirs);
		array_multisort($array_lowercase, SORT_ASC, SORT_STRING, $dirs);
		$array_lowercase = array_map('strtolower', $files);
		array_multisort($array_lowercase, SORT_ASC, SORT_STRING, $files);
		
		//list the directories
			for ($j=0;$j<sizeof($dirs);$j++) 
			{
			//check if $fckphp_configured not to show this folder
			$hide=false;
			for($i=0;$i<sizeof($this->fckphp_config['ResourceAreas'][$this->type]['HideFolders']);$i++) 
				$hide=(ereg($this->fckphp_config['ResourceAreas'][$this->type]['HideFolders'][$i],$dirs[$j])?true:$hide);
			
			if (!$hide) echo "\t\t<Folder name=\"$dirs[$j]\" />\n";
			}
		
		echo "\t</Folders>\n";
		echo "\t<Files>\n";
		
//list the files
		for ($i=0;$i<sizeof($files);$i++) 
		{
			$lastdot=strrpos($files[$i],".");
			$ext=(($lastdot!==false)?(substr($files[$i],$lastdot+1)):"");
			
			if (in_array(strtolower($ext),$this->fckphp_config['ResourceAreas'][$this->type]['AllowedExtensions'])) 
			{
			
				//check if$fckphp_configured not to show this file
				$editable=$hide=false;
				for($j=0;$j<sizeof($this->fckphp_config['ResourceAreas'][$this->type]['HideFiles']);$j++) 
					$hide=(ereg($this->fckphp_config['ResourceAreas'][$this->type]['HideFiles'][$j],$files[$i])?true:$hide);
				
				if (!$hide) 
				{	
					echo "\t\t<File name=\"".htmlentities($files[$i])."\" size=\"".ceil(filesize($this->real_cwd."/".$files[$i])/1024)."\" />\n";	
				}

			}
			
		}
	
		echo "\t</Files>\n"; 
		echo "</Connector>\n";
	}
	
}

?>